#include <sourcemod>
#include <sdkhooks>
#include <cstrike>
#include <sdktools_entinput>
#include <sdktools_functions>

new String:WeaponName[128][64];
new WeaponTeam[128];
new String:ProcessingClientWeapons[MAXPLAYERS + 1][1024];

new Handle:hCvarAlwaysReplace = INVALID_HANDLE;
new bool:CvarAlwaysReplace = false;

public Plugin:myinfo =
{
	name = "Always Weapon Skins",
	author = "Neuro Toxin",
	description = "Players always get their weapon skins!",
	version = "1.6",
}

public OnPluginStart()
{
	CreateConvars();
	LoadWeaponInfo();

	new Handle:hVersion = CreateConVar("aws_version", "1.6");
	new flags = GetConVarFlags(hVersion);
	flags |= FCVAR_NOTIFY;
	SetConVarFlags(hVersion, flags);
}

public OnMapStart()
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if (!IsClientConnected(client))
			continue;
			
		if (!IsClientInGame(client))
			continue;
			
		OnClientPutInServer(client);
	}
}

public OnConfigsExecuted()
{
	LoadConvars();
}

public OnClientPutInServer(client)
{
	ProcessingClientWeapons[client] = "";
	SDKHook(client, SDKHook_WeaponEquipPost, OnPostWeaponEquip);
}

public Action:OnPostWeaponEquip(client, weapon)
{
	// Get the weapons classname
	new String:classname[64];
	GetEdictClassname(weapon, classname, sizeof(classname));
	
	// Return if this weapon is not configured in 'alwaysweaponskins.txt'
	new weaponteam = GetWeaponTeam(classname);
	if (weaponteam == -2)
	{
		//PrintToConsole(client, "[SM] -> Skipped: Not configured");
		return Plugin_Continue;
	}
	
	// Get weapon index
	new weaponindex = GetEntProp(weapon, Prop_Send, "m_iItemDefinitionIndex");
	//new m_iEntityLevel = GetEntProp(weapon, Prop_Send, "m_iEntityLevel");
	new m_iEntityQuality = GetEntProp(weapon, Prop_Send, "m_iEntityQuality");
	new m_iItemIDHigh = GetEntProp(weapon, Prop_Send, "m_iItemIDHigh");
	new m_iItemIDLow = GetEntProp(weapon, Prop_Send, "m_iItemIDLow");
	//new m_iAccountID = GetEntProp(weapon, Prop_Send, "m_iAccountID");
	new check = m_iEntityQuality + m_iItemIDHigh + m_iItemIDLow;

	// remake weapon string for m4a1_silencer, usp_silencer and cz75a
	switch (weaponindex)
	{
		case 60:
		{
			classname = "weapon_m4a1_silencer";
			check -= 3;
		}
		case 61:
		{
			classname = "weapon_usp_silencer";
			check -= 3;
		}
		case 63:
		{
			classname = "weapon_cz75a";
			check -= 3;
		}
	}
	
	//PrintToConsole(client, "[SM] OnPostWeaponEquip(client=%d, weapon=%d, classname=%s, weaponindex=%d)", client, weapon, classname, weaponindex);
	
	// Get the clients process list
	new String:processlist[1024];
	processlist = ProcessingClientWeapons[client];
	
	// If the weapon is processing, clean it off the processing
	// list and stop processing
	new String:listname[66];
	Format(listname, sizeof(listname), ":%s:", classname);
	if (StrContains(processlist, listname) > -1)
	{
		ReplaceString(processlist, sizeof(processlist), listname, "");
		ProcessingClientWeapons[client] = processlist;
		
		//PrintToConsole(client, "[WS] Weapon Process List: %s", processlist);
		return Plugin_Continue;
	}
	
	// Skip if previously owned
	new m_hPrevOwner = GetEntProp(weapon, Prop_Send, "m_hPrevOwner");
	if (m_hPrevOwner > 0)
	{
		//PrintToConsole(client, "[SM] -> Skipped: Already owned");
		return Plugin_Continue;
	}
	
	//PrintToConsole(client, "[SM] m_iEntityLevel -> %d", m_iEntityLevel);
	//PrintToConsole(client, "[SM] m_iEntityQuality -> %d", m_iEntityQuality);
	//PrintToConsole(client, "[SM] m_iItemIDHigh -> %d", m_iItemIDHigh);
	//PrintToConsole(client, "[SM] m_iItemIDLow -> %d", m_iItemIDLow);
	//PrintToConsole(client, "[SM] m_iAccountID -> %d", m_iAccountID);
	//PrintToConsole(client, "[SM] m_hPrevOwner -> %d", m_hPrevOwner);
	//PrintToConsole(client, "[SM] check -> %d", check);
	
	// Check if the weapon is already a skinned weapon
	if (check > 4)
	{
		//PrintToConsole(client, "[SM] -> Skipped: Already skinned weapon");
		return Plugin_Continue;
	}
	
	// If the weapon doesnt require a different team then stop processing
	new playerteam = GetEntProp(client, Prop_Data, "m_iTeamNum");
	if (!CvarAlwaysReplace)
	{
		if (weaponteam == -1)
		{
			PrintToConsole(client, "[SM] -> Skipped: Weapon is on both teams");
			return Plugin_Continue;
		}
		if (weaponteam == playerteam)
		{
			PrintToConsole(client, "[SM] -> Skipped: Player on correct team");
			return Plugin_Continue;
		}
	}
	
	//PrintToConsole(client, "[SM] -> Processing Weapon Switch");
	
	// Debug logging
	new String:teamname[32];
	if (weaponteam == -1)
		teamname = "Any";
	else
		GetTeamName(weaponteam, teamname, sizeof(teamname));
	PrintToConsole(client, "[WS] Respawning %s for team %s", classname, teamname);
		
	// Update the process list with the new weapon
	Format(processlist, sizeof(processlist), "%s:%s:", processlist, classname);
	ProcessingClientWeapons[client] = processlist;
	
	if (strlen(processlist) >= sizeof(processlist) - 8)
	{
		ProcessingClientWeapons[client] = "";
		PrintToConsole(client, "[WS] Processlist has been reset from an overflow");
		return Plugin_Continue;
	}
	PrintToConsole(client, "[WS] Weapon Process List: %s", processlist);
	
	// Remove current weapon from player
	AcceptEntityInput(weapon, "Kill");
	
	// Switch team if required
	if (weaponteam > -1)
		SetEntProp(client, Prop_Data, "m_iTeamNum", weaponteam);
	
	// Give player new weapon
	GivePlayerItem(client, classname);
	
	// Switch team back if required
	if (weaponteam > -1)
		SetEntProp(client, Prop_Data, "m_iTeamNum", playerteam);
		
	return Plugin_Continue;
}

public OnClientDisconnect(client)
{
	SDKUnhook(client, SDKHook_WeaponEquipPost, OnPostWeaponEquip);
}

stock LoadWeaponInfo()
{
	CleanWeaponInfo();
	
	decl String:fullpath[] = "cfg/sourcemod/alwaysweaponskins.txt";
	
	new Handle:file = OpenFile(fullpath, "r");
	if (file == INVALID_HANDLE)
	{
		PrintToServer("[GGAG]: Unable to load weapon '%s'", fullpath);
		return;
	}
	
	new String:line[256];
	new String:explodedline[2][64];
	new weapon = 1;
	
	// Loop through each line
	while (ReadFileLine(file, line, sizeof(line)))
	{
		// Trim the line of the bat
		TrimString(line);
		
		// Continue if the line is empty
		if (StrEqual(line, ""))
			continue;
		
		// Continue if line is commented out
		if (StrContains(line, "//") == 0)
			continue;
		
		// Explode the string and trim the value
		ExplodeString(line, ",", explodedline, 2, 128, true);
		TrimString(explodedline[0]);
		TrimString(explodedline[1]);

		WeaponName[weapon] = explodedline[0];
		WeaponTeam[weapon] = WeaponTeamToInt(explodedline[1]);
		
		weapon++;
	}
	
	// Close the file handle
	CloseHandle(file);	
}

stock CleanWeaponInfo()
{
	for (new weapon = 0; weapon < 64; weapon++)
	{
		WeaponName[weapon] = "";
		WeaponTeam[weapon] = 0;
	}
}

stock WeaponTeamToInt(String:team[])
{
	if (StrEqual(team, "T"))
		return CS_TEAM_T;
	else if (StrEqual(team, "CT"))
		return CS_TEAM_CT;
	else
		return -1;	
}

stock GetWeaponTeam(const String:weaponname[])
{
	for (new weapon = 0; weapon < 128; weapon++)
	{
		if (StrEqual(WeaponName[weapon], weaponname))
			return WeaponTeam[weapon];
	}
	return -2;
}

stock CreateConvars()
{
	hCvarAlwaysReplace = CreateConVar("aws_alwaysreplace", "0", "Forces clients to always replace weapons once");
	
	HookConVarChange(hCvarAlwaysReplace, OnCvarAlwaysReplaceChanged);
}

stock LoadConvars()
{
	CvarAlwaysReplace = GetConVarBool(hCvarAlwaysReplace);
}

public OnCvarAlwaysReplaceChanged(Handle:cvar, const String:oldVal[], const String:newVal[])
{
	CvarAlwaysReplace = StringToInt(newVal) == 0 ? false : true;
}